from . import CLAIMS as CLAIMS
from ... import nglog as nglog
from ..endpoints import User as User
from ._claims import AddUserClaim as AddUserClaim, DeleteUserClaim as DeleteUserClaim, GetUserClaim as GetUserClaim, ProxyGenerateClientOTPClaim as ProxyGenerateClientOTPClaim, ProxyGenerateServiceOTPClaim as ProxyGenerateServiceOTPClaim, ProxyGetCertificateClaim as ProxyGetCertificateClaim, ProxyRequestClientCertificateClaim as ProxyRequestClientCertificateClaim, ProxyRequestServiceCertificateClaim as ProxyRequestServiceCertificateClaim, ProxyRevokeCertificateClaim as ProxyRevokeCertificateClaim, ReadAuditorDataClaim as ReadAuditorDataClaim, ReadCDNARateLimiterDataClaim as ReadCDNARateLimiterDataClaim, ReadRateLimiterDataClaim as ReadRateLimiterDataClaim, RequestAPITokenClaim as RequestAPITokenClaim, RequestClientCertificateClaim as RequestClientCertificateClaim, RequestClientCredentialsClaim as RequestClientCredentialsClaim, RequestServiceCertificateClaim as RequestServiceCertificateClaim, SearchEndpointsClaim as SearchEndpointsClaim, UpdateUserClaim as UpdateUserClaim, WriteCDNARateLimiterDataClaim as WriteCDNARateLimiterDataClaim, WriteRateLimiterDataClaim as WriteRateLimiterDataClaim
from .granting import GrantAddUserClaim as GrantAddUserClaim, GrantDeleteUserClaim as GrantDeleteUserClaim, GrantGenerateRequestClientCertificateOTPClaim as GrantGenerateRequestClientCertificateOTPClaim, GrantGenerateRequestServiceCertificateOTPClaim as GrantGenerateRequestServiceCertificateOTPClaim, GrantGetUserClaim as GrantGetUserClaim, GrantProxyGenerateClientOTPClaim as GrantProxyGenerateClientOTPClaim, GrantProxyGenerateServiceOTPClaim as GrantProxyGenerateServiceOTPClaim, GrantProxyGetCertificateClaim as GrantProxyGetCertificateClaim, GrantProxyRequestClientCertificateClaim as GrantProxyRequestClientCertificateClaim, GrantProxyRequestServiceCertificateClaim as GrantProxyRequestServiceCertificateClaim, GrantProxyRevokeCertificateClaim as GrantProxyRevokeCertificateClaim, GrantRequestClientCertificateClaim as GrantRequestClientCertificateClaim, GrantRequestServiceCertificateClaim as GrantRequestServiceCertificateClaim, GrantSearchEndpointsClaim as GrantSearchEndpointsClaim, GrantUpdateUserClaim as GrantUpdateUserClaim
from .types import ServiceIDPrefix as ServiceIDPrefix
from radkit_common.access.helpers import validate_domains as validate_domains
from radkit_common.identities import ClientID as ClientID, Email as Email, ServiceID as ServiceID

def get_standard_domain_admin_claims(domain: str, wildcard: bool = False, include_otp: bool = False, service_id_prefixes: list[ServiceIDPrefix] | None = None) -> list[CLAIMS]: ...
def get_standard_system_admin_claims(domain: str, wildcard: bool = False, include_domain_admin: bool = False, include_otp: bool = False, service_id_prefixes: list[ServiceIDPrefix] | None = None) -> list[CLAIMS]: ...
def get_standard_super_admin_claims(domain: str, wildcard: bool = False, include_system_admin: bool = False, include_domain_admin: bool = False, include_otp: bool = False, service_id_prefixes: list[ServiceIDPrefix] | None = None) -> list[CLAIMS]: ...
def get_standard_root_claims() -> list[CLAIMS]: ...
def grant_machine_ids(user: User, machine_ids: Email | list[Email], grant_admin_level: int = 0) -> None: ...
async def grant_service_ids(user: User, service_ids: ServiceID | list[ServiceID], include_otp: bool = False) -> None: ...
